import 'package:flutter/cupertino.dart';
import 'moduler_route.dart';

class Modules {
  static final Modules _singleton = Modules._internal();
  final List<ModulerRoute> _modules = [];

  factory Modules() {
    return _singleton;
  }

  Modules._internal();

  void addModules(List<ModulerRoute> modules) {
    _modules.addAll(modules);
  }

  List<ModulerRoute> getModules() => _modules;

  static T? arguments<T extends Argument>(RouteSettings settings, String path, T Function(Map<String, dynamic> data) fromMap) {
  if (settings.name != null) {
    String kPath = path.substring(path.length - 1) == "/" ? path : "$path/";
    final list = settings.name!.split(kPath);
    if (list.length > 1) {
      final split = list[1].split("/");
      Map<String, String> result = {};
      for (int a = 0; a < split.length; a = a + 2) {
        result[split[a]] = split[a + 1];
      }
      T arg1 = fromMap(result);
      return arg1 ;
    } else {
      return settings.arguments as T;
    }
  }
  return null;
}
}

abstract class Argument {
  Map<String, dynamic> toMap();
  factory Argument.fromMap(Map<String, dynamic> map) => throw UnimplementedError();
}

